/*
 * copyright (c)2009 http://wamsoft.jp
 * zlib license
 */
#ifndef __SQOBJECT_H__
#define __SQOBJECT_H__

// ^
#ifndef SQOBJECTNAME
#define SQOBJECTNAME _SC("Object")
#endif

#include "sqobjectinfo.h"

namespace sqobject {

const SQChar *getString(HSQUIRRELVM v, int idx);

/**
 * IuWFNgp
 */
class Object {

protected:
	// ȎQ
	ObjectInfo self;
	// ̃IuWFNg҂ĂXbḧꗗ
	ObjectInfo _waitThreadList;
	// delegate
	ObjectInfo delegate;

public:
	/**
	 * IuWFNg҂̓o^
	 * @param thread Xbh
	 */
	void _addWait(ObjectInfo &thread);
	
	/**
	 * IuWFNg҂̉
	 * @param thread Xbh
	 */
	void _removeWait(ObjectInfo &thread);
	
	/**
	 * RXgN^
	 */
	Object();
	
	/**
	 * RXgN^
	 */
	Object(HSQUIRRELVM v, int delegateIdx=2);

	/**
	 * fXgN^
	 */
	virtual ~Object();

public:
	
	// ------------------------------------------------------------------

	/**
	 * ̃IuWFNg҂ĂPXbh̑҂
	 */
	void notify();
	
	/**
	 * ̃IuWFNg҂ĂSXbh̑҂
	 */
	void notifyAll();
	
	/**
	 * vpeBl擾
	 * @param name vpeB
	 * @return vpeBl
	 */
	SQRESULT _get(HSQUIRRELVM v);

	/**
	 * vpeBɒlݒ
	 * @param name vpeB
	 * @param value vpeBl
	 */
	SQRESULT _set(HSQUIRRELVM v);

	/**
	 * setvpeB̑݊mF
	 * @param name vpeB
	 * @return setvpeB݂ true
	 */
	SQRESULT hasSetProp(HSQUIRRELVM v);
	
	/**
	 * Ϗ̐ݒ
	 */
	SQRESULT setDelegate(HSQUIRRELVM v);

	/**
	 * Ϗ̎擾
	 */
	SQRESULT getDelegate(HSQUIRRELVM v);

public:
	/**
	 * squirrel NXo^
	 */
	static void registerClass();
};

};// namespace

// Oo͗p
#define SQPRINT(v,msg) {\
	SQPRINTFUNCTION print = sq_getprintfunc(v);\
	if (print) {\
		print(v,msg);\
	}\
}

#endif
