/**
 * `𐶐
 * @param x \WX
 * @param y \WY
 * @param w 
 * @param w c
 * @param color hԂF
 * @return `Shape
 */
function createRect(x, y, w, h, color) {
	local rect = ::createInstance("flash.display", "Shape");
	rect.graphics.lineStyle(0,color);
	rect.graphics.beginFill(color);
	rect.graphics.drawRect(0,0,w,h);
	rect.graphics.endFill();
	rect.x = x;
	rect.y = y;
	::getStage().addChild(rect);
	return rect;
}

/**
 * ~𐶐
 * @param x \WX
 * @param y \WY
 * @param r a
 * @param color F
 * @return ~Shape
 */
function createCircle(x, y, r, color) {
	local circle = ::createInstance("flash.display", "Shape");
	circle.graphics.lineStyle(0,color);
	circle.graphics.beginFill(color);
	circle.graphics.drawCircle(0,0,r);
	circle.graphics.endFill();
	circle.x = x;
	circle.y = y;
	::getStage().addChild(circle);
	return circle;
}

/**
 * 摜𐶐
 * @param filename 摜t@C
 * @return 摜
 */
function createImage(filename)
{
	local loader = ::createInstance("flash.display", "Loader");
	loader.load(createInstance("flash.net", "URLRequest", filename));
	return loader;
}

/*
 * {^𐶐
 * @param x \WX
 * @param y \WY
 * @param image 摜x[X (image_o.png, image_n.png ̉摜g܂)
 * @param func ꂽƂĂ΂֐(FlashCallerIuWFNg)
 */
function createButton(x, y, image, func)
{
	local button = ::createInstance("flash.display", "SimpleButton");

	// G\t
	local over   = createImage(image + "_o.png");
	local normal = createImage(image + "_n.png");

	button.upState      = normal;
	button.overState    = over;
	button.downState    = over;
	button.hitTestState = over;
	
	// Xi[o^
	button.addEventListener("mouseDown", func.getFlashFunction());
	
	button.x = x;
	button.y = y;

	::getStage().addChild(button);
	return button;
}

// Jn
print("startup!\n");

local onDown = FlashCaller(function(event) { print("button down!\n"); });
local button = createButton(200,10,"button",onDown);
local rect   = createRect(400,300,60,60,0xff0000);
local circle = createCircle(400,300,30,0xffff00);

while (true) {
	local tick = getCurrentTick();
	rect.x = 400 + 200*sin(2 * PI * tick / 1000);
	circle.y = 300 + 200*sin(2 * PI * tick / 1000);
	suspend();
};

